// GENERATED CONTENT - DO NOT EDIT MANUALLY!

part of '../tuple.dart';

/// A [Tuple] of 2 items.
@sealed
class Tuple2<I0, I1> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple2(0, 1);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple2(0, 1);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  @override
  List<Object> get props => [i0, i1];

  /// Creates a [Tuple] of 2 items.
  ///
  /// ```
  /// final tuple = Tuple2(0, 1);
  ///
  /// print(tuple); // "(0, 1)"
  /// ```
  const Tuple2(
    this.i0,
    this.i1,
  ) : super._();
}

/// A [Tuple] of 3 items.
@sealed
class Tuple3<I0, I1, I2> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple3(0, 1, 2);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple3(0, 1, 2);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// ```
  /// final tuple = Tuple3(0, 1, 2);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  @override
  List<Object> get props => [i0, i1, i2];

  /// Creates a [Tuple] of 3 items.
  ///
  /// ```
  /// final tuple = Tuple3(0, 1, 2);
  ///
  /// print(tuple); // "(0, 1, 2)"
  /// ```
  const Tuple3(
    this.i0,
    this.i1,
    this.i2,
  ) : super._();
}

/// A [Tuple] of 4 items.
@sealed
class Tuple4<I0, I1, I2, I3> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple4(0, 1, 2, 3);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple4(0, 1, 2, 3);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// ```
  /// final tuple = Tuple4(0, 1, 2, 3);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// ```
  /// final tuple = Tuple4(0, 1, 2, 3);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  @override
  List<Object> get props => [i0, i1, i2, i3];

  /// Creates a [Tuple] of 4 items.
  ///
  /// ```
  /// final tuple = Tuple4(0, 1, 2, 3);
  ///
  /// print(tuple); // "(0, 1, 2, 3)"
  /// ```
  const Tuple4(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
  ) : super._();
}

/// A [Tuple] of 5 items.
@sealed
class Tuple5<I0, I1, I2, I3, I4> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple5(0, 1, 2, 3, 4);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple5(0, 1, 2, 3, 4);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// ```
  /// final tuple = Tuple5(0, 1, 2, 3, 4);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// ```
  /// final tuple = Tuple5(0, 1, 2, 3, 4);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// ```
  /// final tuple = Tuple5(0, 1, 2, 3, 4);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  @override
  List<Object> get props => [i0, i1, i2, i3, i4];

  /// Creates a [Tuple] of 5 items.
  ///
  /// ```
  /// final tuple = Tuple5(0, 1, 2, 3, 4);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4)"
  /// ```
  const Tuple5(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
  ) : super._();
}

/// A [Tuple] of 6 items.
@sealed
class Tuple6<I0, I1, I2, I3, I4, I5> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple6(0, 1, 2, 3, 4, 5);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple6(0, 1, 2, 3, 4, 5);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// ```
  /// final tuple = Tuple6(0, 1, 2, 3, 4, 5);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// ```
  /// final tuple = Tuple6(0, 1, 2, 3, 4, 5);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// ```
  /// final tuple = Tuple6(0, 1, 2, 3, 4, 5);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  /// Item 5.
  ///
  /// ```
  /// final tuple = Tuple6(0, 1, 2, 3, 4, 5);
  ///
  /// print(tuple.5); // "5"
  /// ```
  final I5 i5;

  @override
  List<Object> get props => [i0, i1, i2, i3, i4, i5];

  /// Creates a [Tuple] of 6 items.
  ///
  /// ```
  /// final tuple = Tuple6(0, 1, 2, 3, 4, 5);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4, 5)"
  /// ```
  const Tuple6(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
    this.i5,
  ) : super._();
}

/// A [Tuple] of 7 items.
@sealed
class Tuple7<I0, I1, I2, I3, I4, I5, I6> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// ```
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// ```
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// ```
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  /// Item 5.
  ///
  /// ```
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple.5); // "5"
  /// ```
  final I5 i5;

  /// Item 6.
  ///
  /// ```
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple.6); // "6"
  /// ```
  final I6 i6;

  @override
  List<Object> get props => [i0, i1, i2, i3, i4, i5, i6];

  /// Creates a [Tuple] of 7 items.
  ///
  /// ```
  /// final tuple = Tuple7(0, 1, 2, 3, 4, 5, 6);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4, 5, 6)"
  /// ```
  const Tuple7(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
    this.i5,
    this.i6,
  ) : super._();
}

/// A [Tuple] of 8 items.
@sealed
class Tuple8<I0, I1, I2, I3, I4, I5, I6, I7> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// ```
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// ```
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// ```
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  /// Item 5.
  ///
  /// ```
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.5); // "5"
  /// ```
  final I5 i5;

  /// Item 6.
  ///
  /// ```
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.6); // "6"
  /// ```
  final I6 i6;

  /// Item 7.
  ///
  /// ```
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple.7); // "7"
  /// ```
  final I7 i7;

  @override
  List<Object> get props => [i0, i1, i2, i3, i4, i5, i6, i7];

  /// Creates a [Tuple] of 8 items.
  ///
  /// ```
  /// final tuple = Tuple8(0, 1, 2, 3, 4, 5, 6, 7);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4, 5, 6, 7)"
  /// ```
  const Tuple8(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
    this.i5,
    this.i6,
    this.i7,
  ) : super._();
}

/// A [Tuple] of 9 items.
@sealed
class Tuple9<I0, I1, I2, I3, I4, I5, I6, I7, I8> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple9(0, 1, 2, 3, 4, 5, 6, 7, 8);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple9(0, 1, 2, 3, 4, 5, 6, 7, 8);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// ```
  /// final tuple = Tuple9(0, 1, 2, 3, 4, 5, 6, 7, 8);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// ```
  /// final tuple = Tuple9(0, 1, 2, 3, 4, 5, 6, 7, 8);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// ```
  /// final tuple = Tuple9(0, 1, 2, 3, 4, 5, 6, 7, 8);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  /// Item 5.
  ///
  /// ```
  /// final tuple = Tuple9(0, 1, 2, 3, 4, 5, 6, 7, 8);
  ///
  /// print(tuple.5); // "5"
  /// ```
  final I5 i5;

  /// Item 6.
  ///
  /// ```
  /// final tuple = Tuple9(0, 1, 2, 3, 4, 5, 6, 7, 8);
  ///
  /// print(tuple.6); // "6"
  /// ```
  final I6 i6;

  /// Item 7.
  ///
  /// ```
  /// final tuple = Tuple9(0, 1, 2, 3, 4, 5, 6, 7, 8);
  ///
  /// print(tuple.7); // "7"
  /// ```
  final I7 i7;

  /// Item 8.
  ///
  /// ```
  /// final tuple = Tuple9(0, 1, 2, 3, 4, 5, 6, 7, 8);
  ///
  /// print(tuple.8); // "8"
  /// ```
  final I8 i8;

  @override
  List<Object> get props => [i0, i1, i2, i3, i4, i5, i6, i7, i8];

  /// Creates a [Tuple] of 9 items.
  ///
  /// ```
  /// final tuple = Tuple9(0, 1, 2, 3, 4, 5, 6, 7, 8);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4, 5, 6, 7, 8)"
  /// ```
  const Tuple9(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
    this.i5,
    this.i6,
    this.i7,
    this.i8,
  ) : super._();
}

/// A [Tuple] of 10 items.
@sealed
class Tuple10<I0, I1, I2, I3, I4, I5, I6, I7, I8, I9> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple10(0, 1, 2, 3, 4, 5, 6, 7, 8, 9);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple10(0, 1, 2, 3, 4, 5, 6, 7, 8, 9);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// ```
  /// final tuple = Tuple10(0, 1, 2, 3, 4, 5, 6, 7, 8, 9);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// ```
  /// final tuple = Tuple10(0, 1, 2, 3, 4, 5, 6, 7, 8, 9);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// ```
  /// final tuple = Tuple10(0, 1, 2, 3, 4, 5, 6, 7, 8, 9);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  /// Item 5.
  ///
  /// ```
  /// final tuple = Tuple10(0, 1, 2, 3, 4, 5, 6, 7, 8, 9);
  ///
  /// print(tuple.5); // "5"
  /// ```
  final I5 i5;

  /// Item 6.
  ///
  /// ```
  /// final tuple = Tuple10(0, 1, 2, 3, 4, 5, 6, 7, 8, 9);
  ///
  /// print(tuple.6); // "6"
  /// ```
  final I6 i6;

  /// Item 7.
  ///
  /// ```
  /// final tuple = Tuple10(0, 1, 2, 3, 4, 5, 6, 7, 8, 9);
  ///
  /// print(tuple.7); // "7"
  /// ```
  final I7 i7;

  /// Item 8.
  ///
  /// ```
  /// final tuple = Tuple10(0, 1, 2, 3, 4, 5, 6, 7, 8, 9);
  ///
  /// print(tuple.8); // "8"
  /// ```
  final I8 i8;

  /// Item 9.
  ///
  /// ```
  /// final tuple = Tuple10(0, 1, 2, 3, 4, 5, 6, 7, 8, 9);
  ///
  /// print(tuple.9); // "9"
  /// ```
  final I9 i9;

  @override
  List<Object> get props => [i0, i1, i2, i3, i4, i5, i6, i7, i8, i9];

  /// Creates a [Tuple] of 10 items.
  ///
  /// ```
  /// final tuple = Tuple10(0, 1, 2, 3, 4, 5, 6, 7, 8, 9);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4, 5, 6, 7, 8, 9)"
  /// ```
  const Tuple10(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
    this.i5,
    this.i6,
    this.i7,
    this.i8,
    this.i9,
  ) : super._();
}

/// A [Tuple] of 11 items.
@sealed
class Tuple11<I0, I1, I2, I3, I4, I5, I6, I7, I8, I9, I10> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple11(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple11(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// ```
  /// final tuple = Tuple11(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// ```
  /// final tuple = Tuple11(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// ```
  /// final tuple = Tuple11(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  /// Item 5.
  ///
  /// ```
  /// final tuple = Tuple11(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
  ///
  /// print(tuple.5); // "5"
  /// ```
  final I5 i5;

  /// Item 6.
  ///
  /// ```
  /// final tuple = Tuple11(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
  ///
  /// print(tuple.6); // "6"
  /// ```
  final I6 i6;

  /// Item 7.
  ///
  /// ```
  /// final tuple = Tuple11(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
  ///
  /// print(tuple.7); // "7"
  /// ```
  final I7 i7;

  /// Item 8.
  ///
  /// ```
  /// final tuple = Tuple11(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
  ///
  /// print(tuple.8); // "8"
  /// ```
  final I8 i8;

  /// Item 9.
  ///
  /// ```
  /// final tuple = Tuple11(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
  ///
  /// print(tuple.9); // "9"
  /// ```
  final I9 i9;

  /// Item 10.
  ///
  /// ```
  /// final tuple = Tuple11(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
  ///
  /// print(tuple.10); // "10"
  /// ```
  final I10 i10;

  @override
  List<Object> get props => [i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10];

  /// Creates a [Tuple] of 11 items.
  ///
  /// ```
  /// final tuple = Tuple11(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10)"
  /// ```
  const Tuple11(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
    this.i5,
    this.i6,
    this.i7,
    this.i8,
    this.i9,
    this.i10,
  ) : super._();
}

/// A [Tuple] of 12 items.
@sealed
class Tuple12<I0, I1, I2, I3, I4, I5, I6, I7, I8, I9, I10, I11> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple12(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple12(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// ```
  /// final tuple = Tuple12(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// ```
  /// final tuple = Tuple12(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// ```
  /// final tuple = Tuple12(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  /// Item 5.
  ///
  /// ```
  /// final tuple = Tuple12(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11);
  ///
  /// print(tuple.5); // "5"
  /// ```
  final I5 i5;

  /// Item 6.
  ///
  /// ```
  /// final tuple = Tuple12(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11);
  ///
  /// print(tuple.6); // "6"
  /// ```
  final I6 i6;

  /// Item 7.
  ///
  /// ```
  /// final tuple = Tuple12(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11);
  ///
  /// print(tuple.7); // "7"
  /// ```
  final I7 i7;

  /// Item 8.
  ///
  /// ```
  /// final tuple = Tuple12(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11);
  ///
  /// print(tuple.8); // "8"
  /// ```
  final I8 i8;

  /// Item 9.
  ///
  /// ```
  /// final tuple = Tuple12(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11);
  ///
  /// print(tuple.9); // "9"
  /// ```
  final I9 i9;

  /// Item 10.
  ///
  /// ```
  /// final tuple = Tuple12(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11);
  ///
  /// print(tuple.10); // "10"
  /// ```
  final I10 i10;

  /// Item 11.
  ///
  /// ```
  /// final tuple = Tuple12(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11);
  ///
  /// print(tuple.11); // "11"
  /// ```
  final I11 i11;

  @override
  List<Object> get props => [i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11];

  /// Creates a [Tuple] of 12 items.
  ///
  /// ```
  /// final tuple = Tuple12(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11)"
  /// ```
  const Tuple12(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
    this.i5,
    this.i6,
    this.i7,
    this.i8,
    this.i9,
    this.i10,
    this.i11,
  ) : super._();
}

/// A [Tuple] of 13 items.
@sealed
class Tuple13<I0, I1, I2, I3, I4, I5, I6, I7, I8, I9, I10, I11, I12> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple13(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple13(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// ```
  /// final tuple = Tuple13(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// ```
  /// final tuple = Tuple13(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// ```
  /// final tuple = Tuple13(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  /// Item 5.
  ///
  /// ```
  /// final tuple = Tuple13(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
  ///
  /// print(tuple.5); // "5"
  /// ```
  final I5 i5;

  /// Item 6.
  ///
  /// ```
  /// final tuple = Tuple13(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
  ///
  /// print(tuple.6); // "6"
  /// ```
  final I6 i6;

  /// Item 7.
  ///
  /// ```
  /// final tuple = Tuple13(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
  ///
  /// print(tuple.7); // "7"
  /// ```
  final I7 i7;

  /// Item 8.
  ///
  /// ```
  /// final tuple = Tuple13(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
  ///
  /// print(tuple.8); // "8"
  /// ```
  final I8 i8;

  /// Item 9.
  ///
  /// ```
  /// final tuple = Tuple13(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
  ///
  /// print(tuple.9); // "9"
  /// ```
  final I9 i9;

  /// Item 10.
  ///
  /// ```
  /// final tuple = Tuple13(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
  ///
  /// print(tuple.10); // "10"
  /// ```
  final I10 i10;

  /// Item 11.
  ///
  /// ```
  /// final tuple = Tuple13(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
  ///
  /// print(tuple.11); // "11"
  /// ```
  final I11 i11;

  /// Item 12.
  ///
  /// ```
  /// final tuple = Tuple13(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
  ///
  /// print(tuple.12); // "12"
  /// ```
  final I12 i12;

  @override
  List<Object> get props => [i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12];

  /// Creates a [Tuple] of 13 items.
  ///
  /// ```
  /// final tuple = Tuple13(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12)"
  /// ```
  const Tuple13(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
    this.i5,
    this.i6,
    this.i7,
    this.i8,
    this.i9,
    this.i10,
    this.i11,
    this.i12,
  ) : super._();
}

/// A [Tuple] of 14 items.
@sealed
class Tuple14<I0, I1, I2, I3, I4, I5, I6, I7, I8, I9, I10, I11, I12, I13> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  /// Item 5.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple.5); // "5"
  /// ```
  final I5 i5;

  /// Item 6.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple.6); // "6"
  /// ```
  final I6 i6;

  /// Item 7.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple.7); // "7"
  /// ```
  final I7 i7;

  /// Item 8.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple.8); // "8"
  /// ```
  final I8 i8;

  /// Item 9.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple.9); // "9"
  /// ```
  final I9 i9;

  /// Item 10.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple.10); // "10"
  /// ```
  final I10 i10;

  /// Item 11.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple.11); // "11"
  /// ```
  final I11 i11;

  /// Item 12.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple.12); // "12"
  /// ```
  final I12 i12;

  /// Item 13.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple.13); // "13"
  /// ```
  final I13 i13;

  @override
  List<Object> get props => [i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13];

  /// Creates a [Tuple] of 14 items.
  ///
  /// ```
  /// final tuple = Tuple14(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13)"
  /// ```
  const Tuple14(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
    this.i5,
    this.i6,
    this.i7,
    this.i8,
    this.i9,
    this.i10,
    this.i11,
    this.i12,
    this.i13,
  ) : super._();
}

/// A [Tuple] of 15 items.
@sealed
class Tuple15<I0, I1, I2, I3, I4, I5, I6, I7, I8, I9, I10, I11, I12, I13, I14> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  /// Item 5.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.5); // "5"
  /// ```
  final I5 i5;

  /// Item 6.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.6); // "6"
  /// ```
  final I6 i6;

  /// Item 7.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.7); // "7"
  /// ```
  final I7 i7;

  /// Item 8.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.8); // "8"
  /// ```
  final I8 i8;

  /// Item 9.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.9); // "9"
  /// ```
  final I9 i9;

  /// Item 10.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.10); // "10"
  /// ```
  final I10 i10;

  /// Item 11.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.11); // "11"
  /// ```
  final I11 i11;

  /// Item 12.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.12); // "12"
  /// ```
  final I12 i12;

  /// Item 13.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.13); // "13"
  /// ```
  final I13 i13;

  /// Item 14.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple.14); // "14"
  /// ```
  final I14 i14;

  @override
  List<Object> get props => [i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14];

  /// Creates a [Tuple] of 15 items.
  ///
  /// ```
  /// final tuple = Tuple15(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14)"
  /// ```
  const Tuple15(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
    this.i5,
    this.i6,
    this.i7,
    this.i8,
    this.i9,
    this.i10,
    this.i11,
    this.i12,
    this.i13,
    this.i14,
  ) : super._();
}

/// A [Tuple] of 16 items.
@sealed
class Tuple16<I0, I1, I2, I3, I4, I5, I6, I7, I8, I9, I10, I11, I12, I13, I14, I15> extends Tuple {
  /// Item 0.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.0); // "0"
  /// ```
  final I0 i0;

  /// Item 1.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.1); // "1"
  /// ```
  final I1 i1;

  /// Item 2.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.2); // "2"
  /// ```
  final I2 i2;

  /// Item 3.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.3); // "3"
  /// ```
  final I3 i3;

  /// Item 4.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.4); // "4"
  /// ```
  final I4 i4;

  /// Item 5.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.5); // "5"
  /// ```
  final I5 i5;

  /// Item 6.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.6); // "6"
  /// ```
  final I6 i6;

  /// Item 7.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.7); // "7"
  /// ```
  final I7 i7;

  /// Item 8.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.8); // "8"
  /// ```
  final I8 i8;

  /// Item 9.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.9); // "9"
  /// ```
  final I9 i9;

  /// Item 10.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.10); // "10"
  /// ```
  final I10 i10;

  /// Item 11.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.11); // "11"
  /// ```
  final I11 i11;

  /// Item 12.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.12); // "12"
  /// ```
  final I12 i12;

  /// Item 13.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.13); // "13"
  /// ```
  final I13 i13;

  /// Item 14.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.14); // "14"
  /// ```
  final I14 i14;

  /// Item 15.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple.15); // "15"
  /// ```
  final I15 i15;

  @override
  List<Object> get props => [i0, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15];

  /// Creates a [Tuple] of 16 items.
  ///
  /// ```
  /// final tuple = Tuple16(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15);
  ///
  /// print(tuple); // "(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15)"
  /// ```
  const Tuple16(
    this.i0,
    this.i1,
    this.i2,
    this.i3,
    this.i4,
    this.i5,
    this.i6,
    this.i7,
    this.i8,
    this.i9,
    this.i10,
    this.i11,
    this.i12,
    this.i13,
    this.i14,
    this.i15,
  ) : super._();
}
